var _excluded = ["className", "isDisabled", "isInvalid", "id", "label", "onBlur", "onChange", "value"];
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
import React from 'react';
import { StyledTextArea } from './partials/StyledTextArea';
import { StyledOuterWrapper } from './partials/StyledOuterWrapper';
import { StyledLabel } from './partials/StyledLabel';
import { StyledInput } from './partials/StyledInput';
import { useExternalId } from '../../hooks/useExternalId';
import { useFocus } from '../../hooks/useFocus';
import { useInputValue } from '../../hooks/useInputValue';
export var TextArea = /*#__PURE__*/React.forwardRef(function (_ref, ref) {
  var className = _ref.className,
    isDisabled = _ref.isDisabled,
    isInvalid = _ref.isInvalid,
    externalId = _ref.id,
    label = _ref.label,
    onBlur = _ref.onBlur,
    _onChange = _ref.onChange,
    value = _ref.value,
    rest = _objectWithoutProperties(_ref, _excluded);
  var id = useExternalId('text-area', externalId);
  var _useFocus = useFocus(onBlur),
    hasFocus = _useFocus.hasFocus,
    onLocalBlur = _useFocus.onLocalBlur,
    onLocalFocus = _useFocus.onLocalFocus;
  var _useInputValue = useInputValue(value),
    committedValue = _useInputValue.committedValue,
    hasValue = _useInputValue.hasValue,
    onValueChange = _useInputValue.onValueChange;
  return /*#__PURE__*/React.createElement(StyledTextArea, {
    className: className
  }, /*#__PURE__*/React.createElement(StyledOuterWrapper, {
    $hasFocus: hasFocus,
    $isDisabled: isDisabled,
    $isInvalid: isInvalid
  }, /*#__PURE__*/React.createElement(StyledLabel, {
    $hasContent: hasValue,
    $hasFocus: hasFocus,
    htmlFor: id
  }, label), /*#__PURE__*/React.createElement(StyledInput, _extends({
    ref: ref,
    disabled: isDisabled,
    id: id,
    onBlur: onLocalBlur,
    onChange: function onChange(e) {
      onValueChange(e);
      if (_onChange) {
        _onChange(e);
      }
    },
    onFocus: onLocalFocus,
    value: committedValue
  }, rest))));
});
TextArea.displayName = 'TextArea';